"""
Non local filter
===================
Non-local filters use a large region of the image (or all the image) to transform the value of one pixel
Enhances contrast in large almost uniform regions 
Code obtained from:
http://www.scipy-lectures.org/packages/scikit-image/index.html   
"""

import numpy as np
import scipy.misc as misc
from scipy import ndimage
import matplotlib.pyplot as plt

from skimage import exposure
from skimage import data 

# Standard image that comes with the module
camera = data.camera()
# Key step below: create explosure to a given image
camera_equalized = exposure.equalize_hist(camera)

plt.figure(figsize=(9, 3))

plt.subplot(121)
plt.imshow(camera, cmap=plt.cm.gray)
plt.axis('off')

plt.subplot(122)
plt.imshow(camera_equalized, cmap=plt.cm.gray)
plt.axis('off')

plt.subplots_adjust(wspace=0, hspace=0., top=0.99, bottom=0.01,
                    left=0.01, right=0.99)

plt.show()
