"""
Image convolution
===================
Code modified from examples found at:
http://www.scipy-lectures.org/advanced/image_processing/
"""

import numpy as np
import scipy.misc as misc
from scipy import ndimage
import matplotlib.pyplot as plt

# Use the standard image from the module
#face = misc.face(gray=True)

# Read an image from a file
face = misc.imread('FabioInGray.jpg')

# Four different filters
#k = np.array([[1,1,1],[1,1,0],[1,0,0]])
k = np.array([[0,1,0],[0,1,0],[0,1,0]])
#k = np.array([[0,0,0],[0,1,0],[0,0,0]])
#k = np.array([[0.1,0.1,0.1],[0.1,0.9,0.1],[0.1,0.1,0.1]])

# Key step: convole the image with a kernel
new_face = ndimage.convolve(face, k, mode='constant', cval=0.0)

plt.figure(figsize=(9, 3))

plt.subplot(121)
plt.imshow(face, cmap=plt.cm.gray)
plt.axis('off')

plt.subplot(122)
plt.imshow(new_face, cmap=plt.cm.gray)
plt.axis('off')

plt.subplots_adjust(wspace=0, hspace=0., top=0.99, bottom=0.01,
                    left=0.01, right=0.99)

plt.show()
