"""
Blurring of images
===================
An example showing a process that uses mean filter to blur an image.
Code modified from examples found at:
http://www.scipy-lectures.org/advanced/image_processing/    
"""

import scipy.misc as misc
from scipy import ndimage
import matplotlib.pyplot as plt

face = misc.imread('FabioInGray.jpg')

# Key step: blur image using uniform(mean) filter
# The larger size is, the more blurry the image becomes
local_mean = ndimage.uniform_filter(face, size=30)

plt.figure(figsize=(9, 3))

plt.subplot(121)
plt.imshow(face, cmap=plt.cm.gray)
plt.axis('off')

plt.subplot(122)
plt.imshow(local_mean, cmap=plt.cm.gray)
plt.axis('off')

plt.subplots_adjust(wspace=0, hspace=0., top=0.99, bottom=0.01,
                    left=0.01, right=0.99)

plt.show()
