"""
Image manipulation and numpy arrays
====================================
This example shows how to do image manipulation using common numpy arrays
tricks.
Code modified from examples found at:
http://www.scipy-lectures.org/advanced/image_processing/
"""

import numpy as np
import scipy
import scipy.misc
import matplotlib.pyplot as plt

face = scipy.misc.face(gray=True)
print face.shape
print face.ndim
face[10:300][:] = 255 # Setting rows from 50 to 149 to white

# Obtain number of rows lx and number of columns ly
lx, ly = face.shape
X, Y = np.ogrid[0:lx, 0:ly] # Mesh grid
mask = (X - lx/2)**2 + (Y - ly/2)**2 > lx*ly/4
print mask.shape
face[mask] = 0 # All the locations i,j where mask[i][j] is true is set to black

plt.figure(figsize=(3, 3))
plt.axes([0, 0, 1, 1])
plt.imshow(face, cmap=plt.cm.gray)
plt.axis('off')

plt.show()
